import com.gizmet.tenochca.map.*;
import com.gizmet.tenochca.model.Model;

class com.gizmet.tenochca.map.TerrainLoader 
{
	private static var arrMapInfo = [
		["<<<<<<<<<<<<<<<<##H^^^^^^^^^^^^^^^"],
		["<<<<<<<<<<<<<<<####H^^^^^^^^^^^^^^"],
		["<<<<<<<<<<<<<<#####HH^^^^^^^^^^^^^"],
		["<<<<<<<<<<<<<#######H^^^^^^^^^^^^^"],
		["<<<<<<<<<<<<<#######H^^^^^^^^^^^^^"],
		["<<<<<<<<<<<<<<#######^^^^^^^^^^^^^"],
		["<<<<<<<<<<<<<########HH^^^^^^^^^^^"],
		["<<<<<<<<<<<<#########H^^^^^^^^^^^^"],
		["<<<<<<<<<<<<<#########H^^^^^^^^^^^"],
		["<<<<<<<<<<<<#########H^^^^^^^^^^^^"],
		["<<<<<<<<<<<###########HH^^^^^^^^^^"],
		["<<<<<<<<<<<############H^^^^^^^^^^"],
		["<<<<<<<<<<<############^^^^^^^^^^^"],
		["<<<<<<<<<<<############H^^^^^^^^^^"],
		["<<<<<<<<<<############HH^^^^^^^^^^"],
		["<<<<<<<<<<#############HH^^^^^^^^^"],
		["<<<<<<<<<###############HH^^^^^^^^"],
		["<<<<<<<<#################HH^^^^^^^"],
		["<<<<<<<<##################H^^^^^^^"],
		["<<<<<<<<<#################H^^^^^^^"],
		["<<<<<<<##################HHH^^^^^^"],
		["<<<<<<<###################H^^^^^^^"],
		["<<<<<<<##################HH##^^^^^"],
		["<<<<<<<##################H##^^^^^^"],
		["<<<<<<<##################H##^^^^^^"],
		["<<<<<######################HH^^^^^"],
		["<<<<<#######################H^^^^^"],
		["<<<<<#######################HH^^^^"],
		["<<<<<######################HH^^^^^"],
		["<<<<##########################H^^^"],
		["<<<############################H^^"],
		["<<<##########################HH^^^"],
		["<<<###########################HHH^"],
		["<<<############################H^^"],
		["<<#############################HH^"],
		["<<<###########################H^^^"],
		["<<<##########################HH^^^"],
		["<<<<########################HH^^^^"],
		["<<<<<<#####################HH^^^^^"],
		["<<<<<####################HH##H^^^^"],
		["<<<<<<<<<##HHH##########HH^^^^^^^^"],
		["<<<<<<<<<###^HH######HHH^^^^^^^^^^"],
		["<<<<<<<<<<<<^^H##HHHH^^^^^^^^^^^^^"],
		["<<<<<<<<<<<<<^^^^^^^^^^^^^^^^^^^^^"]
	];

	public static function initTerrain (map) 
	{
		// This method takes the pre-set map definition strings and builds out 
		// the data structure describing the basic map layout.
		var model = Model.getModel();		
		map.grid = new Array();

		for (var i=0; i<TerrainLoader.arrMapInfo.length;i++) {
			var rowArr = new Array();
			var rowTiles = new String(TerrainLoader.arrMapInfo[i]).split('');
			for (var j=0; j<rowTiles.length; j++) {
				switch (rowTiles[j]) {
					case "<":
						var square = new MapSquare("j");
						rowArr.push(square);
						map.markOccupied(j,i);
						break;
					case "#":
						var square = new MapSquare("o");
						rowArr.push(square);
						break;
					case "^":
						var square = new MapSquare("m");
						rowArr.push(square);
						map.markOccupied(j,i);
						break;
					case "H":
						var square = new MapSquare("h");
						rowArr.push(square);
						map.markOccupied(j,i);
						break;
				}
			}
			map.grid.push(rowArr);
		}
		
		// throw the port square in there
		var square = new MapSquare("p");
		map.grid[model.port_y][model.port_x] = square;
		map.markOccupied(model.port_x, model.port_y);
	}

}