import com.gizmet.tenochca.map.*;
import com.gizmet.tenochca.model.Model;

class com.gizmet.tenochca.map.TerrainLoader 
{
		
	// This first string gives a pipe-separated list of rows, each described by
	// the jungle offset from the west map edge, followed by a dot, and the
	// number of open map squares.  All squares east of the last open map
	// square should be filled with mountains.  This string describes the first
	// sixty-one rows of the map, each of which should be fifty squares wide.
	private static var strMapInfo:String =  "23.4|22.7|21.8|20.10|19.12|20.11|19.11|20.10|19.12|18.15|17.15|17.16|18.15|17.15|17.16|16.19|15.20|16.18|15.19|16.19|13.23|14.21|14.22|13.23|13.25|11.28|12.26|11.28|12.28|12.27|10.31|10.30|9.32|10.32|10.31|9.31|9.32|7.36|8.34|7.36|6.38|5.40|6.37|5.40|4.42|3.44|3.43|4.43|4.44|3.44|2.47|2.46|3.43|4.43|3.43|5.39|6.39|8.35|7.37|10.31|13.25";
	// The last four rows are described by the following string, which should 
	// be broken into sets of fifty squares.  There should be 65 rows in total.
	private static var strMapInfoCont:String = "jjjjjjjjjjjjjoooomooooooooooooooooommmmmmmmmmmmmmmjjjjjjjjjjjjjjjjmmmmoooooooooooommmmmmmmmmmmmmmmmmjjjjjjjjjjjjjjjjjjmmoooooooooommmmmmmmmmmmmmmmmmmmjjjjjjjjjjjjjjjjjjmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm";
	
	public static function initTerrain (map) 
	{
		// This method takes the pre-set map definition strings and builds out 
		// the data structure describing the basic map layout.
		var model = Model.getModel();		
		map.grid = new Array();

		var rowDef = TerrainLoader.strMapInfo.split("|");
		for (var i=0; i<rowDef.length; i++) {
			// split out the compressed row definitions and build out the first set of rows
			var row = new Array();
			
			var def = rowDef[i].split(".");
			var jungle = Number(def[0]);
			var open = Number(def[1]);
			var mountain = map.mapWidth - (jungle + open);
			var jcount = 0;
			for (var j=0; j<jungle; j++) {
				var square = new MapSquare("j");
				row.push(square);
				map.markOccupied(jcount,i);
				jcount++;
			}
			for (var j=0; j<open; j++) {
				var square = new MapSquare("o");
				row.push(square);
				jcount++;
			}
			for (var j=0; j<mountain; j++) {
				var square = new MapSquare("m");
				row.push(square);
				map.markOccupied(jcount,i);
				jcount++;
			}
			
			map.grid.push(row);
		}
		
		// build out last rows from definition string
		var rowDef = TerrainLoader.strMapInfoCont.split("");
		for (var i=0; i<rowDef.length; i++) {
			if (i%50 == 0) {
				var row = new Array();
			}
			var square = new MapSquare(rowDef[i]);
			row.push(square);
			if (square.type ne "o") {
				map.markOccupied(jcount,i);
			}
			if (i%50 == 49) {
				map.grid.push(row);
				jcount++;
			}
		}
		
		// throw the port square in there
		var square = new MapSquare("p");
		map.grid[model.port_y][model.port_x] = square;
		map.markOccupied(model.port_x, model.port_y);
	}

}