import com.gizmet.util.*;
import com.gizmet.tenochca.*;
import com.gizmet.tenochca.map.*;
import com.gizmet.tenochca.model.*;

class com.gizmet.tenochca.model.Model {
	
	private static var instanceCount:Number = 0;
	private static var myModel:Model;
	private var broadcaster:EventBroadcaster;
	
	public var map:Map;
	
	public var port_x:Number = 16;
	public var port_y:Number = 0;
	public var mouth_x:Number = 17;
	public var mouth_y:Number = 1;

	public var num_river_sources:Number = 3;
	public var num_additional_river_sources:Number = 2;
	public var river_source_max:Number = 40;
	public var river_source_y_range:Number = 6;
	public var river_source_x_buffer:Number = 2;
	public var river_source_spacer:Number = 6;	
	
	public var max_map_tries = 500;
	public var num_hills = 20;
	public var hill_spacer = 3;
	public var fudge_wave = 20;
		
	public var expedition:Expedition;
	public var initialDate:Date;
	public var currentDate:Date;
	
	private function Model() 
	{
		// initialization stuff
		this.broadcaster = EventBroadcaster.getBroadcaster();
		this.map = Map.getMap();
		Model.instanceCount++;
	}
	
	public static function getModel () 
	{
		// implement singleton pattern
		if (Model.instanceCount < 1) {
			Model.myModel = new Model();
		}
		return Model.myModel;
	}
	
	// public stuffs
	
	public function init()
	{
		this.expedition = new Expedition();
		this.initialDate = new Date(1936,2,1,8,0,0,0);
		this.currentDate = this.initialDate;
	}
	
	public function addHours (hours)
	{
		var millis = this.currentDate.getTime();
		millis += hours * 3600000;  // times hours in milliseconds
		this.currentDate.setTime(millis);
		this.broadcaster.broadcast("DateChanged");
	}
	
	
	
}