import com.gizmet.tenochca.screen.Screen;
import com.gizmet.util.*;
import com.gizmet.tenochca.*;
import com.gizmet.tenochca.model.*;
import com.gizmet.tenochca.ui.*;

class com.gizmet.tenochca.screen.ScreenMap extends Screen 
{	
	private var mapViewer:MapViewer;
	private var broadcaster:EventBroadcaster;
	private var keyHandler:KeyHandler;
	private var model:Model;
	private var metaMode:Boolean;
	
	private var buttonMenu:actionButtonMenu;
	private var arrow_up:MovieClip;
	private var arrow_down:MovieClip;
	private var arrow_left:MovieClip;
	private var arrow_right:MovieClip;
	
	public function ScreenMap()
	{
		this.keyHandler = KeyHandler.getKeyHandler();
		this.broadcaster = EventBroadcaster.getBroadcaster();
		this.model = Model.getModel();
		this.broadcaster.addEventListener("StartPressed", this);
		this.broadcaster.addEventListener("MoveView", this);

		arrow_up.onPress = function () { KeyHandler.getKeyHandler().doOnKeyDown( Key.UP) };
		arrow_down.onPress = function () { KeyHandler.getKeyHandler().doOnKeyDown(Key.DOWN) };
		arrow_left.onPress = function () { KeyHandler.getKeyHandler().doOnKeyDown(Key.LEFT) };
		arrow_right.onPress = function () { KeyHandler.getKeyHandler().doOnKeyDown(Key.RIGHT) };
		
		var map_screen_key_handler = function (target, keyCode) {
			if (target.metaMode) {
				switch (keyCode) {
					case 77:  // M
						trace(com.gizmet.tenochca.map.Map.getMap());
						break;
					case 80: // P
						var model = Model.getModel();
						trace("Expedition position: ("+model.expedition.x+", "+model.expedition.y+")");
						break;
					case 82:  // R
						if (target.mapViewer.revealMode eq "standard") {
							Logger.log("*** Setting revealMode to all");
							target.mapViewer.revealMode = "all";
						}
						else {
							Logger.log("*** Setting revealMode to standard");
							target.mapViewer.revealMode = "standard";
						}
				}
				target.metaMode = false;
			}
			else {
				switch (keyCode) {
					case 81:  // Q
						target.metaMode = true;
						break;
					case Key.DOWN:
					case Key.UP:
					case Key.LEFT:
					case Key.RIGHT:
						target.keyHandler.sendKey("MapViewer", keyCode);
						break;
				}
			}
		}
		
		this.keyHandler.setCallbacks("ScreenMap", this, map_screen_key_handler);
	}
	
	// Event Handlers
	
	private function StartPressed (obj) 
	{
		this.mapViewer.initMap();
	}
	
	private function MoveView (obj) 
	{
		if (this.model.expedition.x == this.model.port_x and this.model.expedition.y == this.model.port_y) {
			this.buttonMenu.setButtonState("Enter Town", "active");
		}
		else {
			this.buttonMenu.setButtonState("Enter Town", "inactive");
		}
	}
}
