import com.gizmet.util.*;

class com.gizmet.tenochca.ui.DialogAlert extends MovieClip
{
	private var keyHandler:KeyHandler;
	private var alertText:TextField;
	private var closeButton:Button;
		
	private function onLoad () 
	{	
		// set up button actions
		this.closeButton.onPress = function () {
			this._parent.closeDialog();
		}
		
		// set up key handling
		this.keyHandler = KeyHandler.getKeyHandler();
		this.keyHandler.setCallbacks("DialogAlert", this, this.dialog_alert_key_handler);
		this.keyHandler.setFocus("DialogAlert");
	}
	
	public function setText (etext) 
	{
		this.alertText.text = etext;
	}
	
	private function closeDialog ()
	{
		this.keyHandler.restoreLastFocus();
		this.removeMovieClip();		
	}

	// keyhandler callback
	
	private function dialog_alert_key_handler  (target, keyCode) 
	{
		switch (keyCode) {
			case Key.SPACE:
			case Key.ENTER:
			case 88:  // X
				target.closeDialog();
				break;
		}
	}
	
}