import com.gizmet.util.*;

class com.gizmet.tenochca.ui.DialogExposition extends MovieClip
{
	private var keyHandler:KeyHandler;
	private var expositionText:TextField;
	private var nextButton:Button;
	private var previousButton:Button;
	private var closeButton:Button;
	
	private var numberOfLines:Number;
	
	private function onLoad () 
	{	
		// set up button actions
		this.previousButton._alpha = 50;
		this.previousButton.onPress = undefined;
		this.nextButton.onPress = function () {
			this._parent.nextText();
		}
		this.closeButton.onPress = function () {
			this._parent.closeDialog();
		}
		
		// set up key handling
		this.keyHandler = KeyHandler.getKeyHandler();
		this.keyHandler.setCallbacks("DialogExposition", this, this.dialog_exposition_key_handler);
		this.keyHandler.setFocus("DialogExposition");
	}
	
	public function setText (etext) 
	{
		this.expositionText.text = etext;
		var fmt = this.expositionText.getTextFormat();
		var met = fmt.getTextExtent(etext);
		var lineHeight = met.ascent + met.descent + fmt.leading;
		this.numberOfLines = Math.floor(this.expositionText._height / lineHeight);
	}
	
	private function closeDialog ()
	{
		this.keyHandler.restoreLastFocus();
		this.removeMovieClip();		
	}

	private function nextText () 
	{
		if (this.expositionText.scroll + this.numberOfLines >= this.expositionText.maxscroll) {
			this.nextButton._alpha = 50;
			this.nextButton.onPress = undefined;
		}
		this.previousButton._alpha = 100;
		this.previousButton.onPress = function () {
			this._parent.previousText();
		}
		this.expositionText.scroll += this.numberOfLines;
	}
	
	private function previousText ()
	{
		this.expositionText.scroll -= this.numberOfLines;
		if (this.expositionText.scroll <= 1) {
			this.previousButton._alpha = 50;
			this.previousButton.onPress = undefined;
		}
		this.nextButton._alpha = 100;
		this.nextButton.onPress = function () {
			this._parent.nextText();
		}
		
	}

	// keyhandler callback
	
	private function dialog_exposition_key_handler  (target, keyCode) 
	{
		switch (keyCode) {
			case Key.SPACE:
			case Key.ENTER:
			case Key.DOWN:
			case Key.RIGHT:
				target.nextText();
				break;
			case Key.LEFT:
			case Key.UP:
				target.previousText();
				break;
			case 88:  // X
				target.closeDialog();
				break;
		}
	}
	
}