import com.gizmet.util.*;
import com.gizmet.tenochca.model.*;

class com.gizmet.tenochca.ui.TimeKeeper extends MovieClip
{
	private var model:Model;
	private var broadcaster:EventBroadcaster;

	private var currentDate: Date;
	private var rotation:Number;
	
	private var dateDisplay:TextField;
	private var cielo:MovieClip;
	private var shadow:MovieClip;
	
	private var monthNames = ["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];
	
	private function TimeKeeper () 
	{
		this.broadcaster = EventBroadcaster.getBroadcaster();
		this.broadcaster.addEventListener("DateChanged", this);
		this.model = Model.getModel();
	}
	
	private function onLoad ()
	{
		this.setDateDisplay(this.model.currentDate);		
		this.setRotation(this.model.currentDate.getHours());
// 		this.shadow.onEnterFrame = this.cielo.onEnterFrame = function () {
// 			this._rotation = (this._rotation - 1)%360;
// 		}
	}

	private function setDateDisplay (myDate)
	{
		var dateString = this.monthNames[myDate.getMonth()] + " " + myDate.getDate() + ", " + myDate.getFullYear() + " ";
		var hour = myDate.getHours() % 12;
		
		dateString += ((hour==0)?12:hour) + ":00 " + ((myDate.getHours()<12) ? "AM" : "PM");
		this.dateDisplay.text = dateString;
	}
	
	private function setRotation (hours) 
	{
		// noon is zero rotation, and we rotate counter-clockwise as time passes
		this.rotation =  (15 * (12 - hours) + 360) % 360;
		this.cielo._rotation = this.rotation;
		this.shadow._rotation = this.rotation;
	}
	
	private function rotateTo (hours)
	{
		var newRotation = (15 * (12 - hours) + 360) % 360;
		this.rotation = newRotation;
		this.cielo.rotateTo = this.shadow.rotateTo = newRotation;
		this.cielo.onEnterFrame = this.shadow.onEnterFrame = function () {
			if ((this._rotation+360)%360 == this.rotateTo) {
				this.onEnterFrame = undefined;
			}
			else {
				this._rotation = (this._rotation - 1) % 360;
			}
		}
	}
	
	// event handlers
	
	private function DateChanged (obj)
	{
		this.setDateDisplay(this.model.currentDate);
		this.rotateTo(this.model.currentDate.getHours());
	}
	
}
