import com.gizmet.util.*;

class com.gizmet.util.Motor extends MovieClip
{
        private var timer:MovieClip;
        private var target:MovieClip;
        private var runTime:Number;
        private var startTime:Number;
        private var endTime:Number;
        private var startX:Number;
        private var startY:Number;
        private var endX:Number;
        private var endY:Number;
        private var diffX:Number;
        private var diffY:Number;
        private var count:Number;
        private var method:String;

        public function Motor (target, runtime, x2, y2, method) 
        {
                var i = SerialIterator.getSerial();
                this.timer = target.createEmptyMovieClip("__timer"+i, i);
                this.timer._parent = this;

                this.target = target;
                this.runTime = runtime;
                this.startTime = getTimer();
                this.endTime = this.startTime + runtime;
                this.startX = this.target._x;
                this.startY = this.target._y;;
                this.endX = x2;
                this.endY = y2;
                this.diffX = endX-startX;
                this.diffY = endY-startY;
                this.method = method;
        }

        public function run()
        {
                this.count = 0;
                this.timer.onEnterFrame = function () {
                        var timeNow = getTimer();
                        if (timeNow >= this._parent.endTime) {
                                this._parent.target._x = this._parent.endX;
                                this._parent.target._y = this._parent.endY;
				this._parent.onDone();
                                this._parent.removeMovieClip();
                                this.onEnterFrame = undefined;
                        }
                        else {
                                var timePast = timeNow - this._parent.startTime;
                                var frak = timePast/this._parent.runTime;

                                // TBD implement different easing methods etc
				switch (this._parent.method) {
					case "quadOut":
						frak = Math.pow(frak,2);
						break;
					case "quadIn":
						frak = 1 - Math.pow(1-frak,2);
						break;
					case "cubeOut":
						frak = Math.pow(frak,3);
						break;
					case "cubeIn":
						frak = 1 - Math.pow(1-frak,3);
						break;
					} 

				this._parent.target._x = this._parent.startX + (frak * this._parent.diffX);
                                this._parent.target._y = this._parent.startY + (frak * this._parent.diffY);
                        }
                }
        }
	
	public function onDone()
	{
		// override me to make Motor do something when it's done moving.
	}

}
